/*Copyright (C) 2004 Ryan Michela
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.net.*;
import java.util.*;

public class HtmlProxyServlet extends HttpServlet
{
	/**
	 * 
	 */
	public HtmlProxyServlet()
	{

	}

	protected void doGet(HttpServletRequest request, HttpServletResponse response)
		throws ServletException, IOException
	{
		//get the url for the resource
		String resource = request.getParameter("resource");
		
		//if none provided, drop out
		if(resource != null)
		{	
			try
			{
				//open up a request to the resource
				URI resourceURI = new URI(resource);
				HttpURLConnection c = (HttpURLConnection)resourceURI.toURL().openConnection();
				c.connect();
				
				//get the connection's input stream and the response's output stream
				BufferedReader in = new BufferedReader(new InputStreamReader(c.getInputStream()));
				PrintWriter out = new PrintWriter(response.getOutputStream());
				
				//read the html into a string buffer
				StringBuffer html = new StringBuffer();
				String line;
				while((line = in.readLine()) != null)
				{
					html.append(line + '\n');
				}
				
				//derelitivize src and href attributes
				StringTokenizer st = new StringTokenizer(html.toString(), "'\"", true);
				html = new StringBuffer();
				while(st.hasMoreTokens())
				{
					String tok = st.nextToken();
					html.append(tok);

					if(tok.toLowerCase().endsWith("src="))
					{
						//append the opening quote
						html.append(st.nextToken());
						
						//get the link
						String link = st.nextToken();
						
						//process the link and append
						if(resourceURI.getPath().equals(""))
						{
							resourceURI = resourceURI.resolve("/");
						}
						
						try
						{
							link = resourceURI.resolve(link).toString();
							html.append(URI.create(request.getRequestURL().toString()).resolve("ResourceServlet").toString() + "?resource=" + link);
						}
						catch(Exception e)
						{
							html.append(link);
						}
						
						//append the closing quote
						html.append(st.nextToken());
					}
					else if(tok.toLowerCase().endsWith("href="))
					{
						//append the opening quote
						html.append(st.nextToken());
						
						//get the link
						String link = st.nextToken();
						
						//process the link and append
						if(resourceURI.getPath().equals(""))
						{
							resourceURI = resourceURI.resolve("/");
						}
						if(!link.startsWith("javascript:"))
						{	
							try
							{
								link = resourceURI.resolve(link).toString();
								html.append(request.getRequestURL().toString() + "?resource=" + link);
							}
							catch(Exception e)
							{
								html.append(link);
							}
						}
						else
						{
							html.append(link);
						}
						
						//append the closing quote
						html.append(st.nextToken());
					}
				}
				
				//write the html out to the response
				response.setContentType(c.getContentType());
				out.println(html.toString());
				out.flush();
			}
			catch(URISyntaxException e)
			{
				response.sendError(404, resource);
			}
			finally
			{
				response.flushBuffer();
			}
		}
	}
}
