/*
 *Copyright (C) 2004 Ryan Michela
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.net.*;
import java.io.*;

public class ResourceServlet extends HttpServlet
{
	/**
	 * 
	 */
	public ResourceServlet()
	{
		super();
	}

	protected void doGet(HttpServletRequest request, HttpServletResponse response)
		throws ServletException, IOException
	{
		//get the url for the resource
		String resource = request.getParameter("resource");
		
		//if none provided, drop out
		if(resource != null)
		{	
			//open up a request to the resource
			HttpURLConnection c = (HttpURLConnection)(new URL(resource)).openConnection();
			c.connect();
			
			//set the resource's mime type
			response.setContentType("application/octet-stream");
			response.setHeader("Content-disposition", "filename=" + resource.substring(resource.lastIndexOf('/') + 1));
			response.setContentLength(c.getContentLength());
			
			//get the connection's input stream and the response's output stream
			InputStream in = c.getInputStream();
			OutputStream out = response.getOutputStream();
			
			//copy the resource contents from the connection to the response
			for(int i = 0; i < c.getContentLength(); i++)
			{
				out.write(in.read());
			}
			
			//flush out the result
			response.flushBuffer();
		}
	}
}
